## nds2-client-swig-0.16.3.tar.gz

=== CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
#------------------------------------------------------------------------
#
# DEFINES:
#   CMAKE_INSTALL_PREFIX  - Installation prefix
#   MATLAB_NO_NODISPLAY   - Run the matlab tests w/o using the -nodisplay option
#   PROG_MATLAB           - Full path to MATLAB executable
#   REPLAY_BLOB_CACHE_DIR - Directory containing replay blobs for testing
#------------------------------------------------------------------------
cmake_minimum_required( VERSION 3.0 FATAL_ERROR )

project(nds2-client-swig
    VERSION "0.16.3"
    LANGUAGES C CXX)

set( CMAKE_CXX_STANDARD 11 )

set( NDS_CONFIG_PATH "${PROJECT_SOURCE_DIR}/config/cmake")
set( PROJECT_BASENAME nds2-client )

set( CMAKE_MODULE_PATH "${NDS_CONFIG_PATH}/Modules;${CMAKE_MODULE_PATH}" )
set( CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE )

include(UseNDS)
include(Cpp11)
include(CheckIncludeFileCXX)

include(CheckCXXCompilerFlag)
include(FindSharedPtr)
include(GNUInstallDirs)
if ( NOT DEFINED CMAKE_INSTALL_PKGDATADIR )
    set( CMAKE_INSTALL_PKGDATADIR ${CMAKE_INSTALL_DATADIR}/nds2-client )
endif( )

cond_set_policy( CMP0042 NEW )

include(ax_packaging)
include(Autotools/Archive/Archive)
include(Autotools/ArchiveX/ArchiveX)

find_package( nds2-client REQUIRED 0.16.1 )

#========================================================================
# Local macros
#========================================================================

macro(is_enabled _VARNAME)
  # ---------------------------------------------------------------------
  #
  # ---------------------------------------------------------------------
  if( ${_VARNAME} )
    set(IS_ENABLED_VALUE "ENABLED")
  else ()
    set(IS_ENABLED_VALUE "DISABLED")
  endif ()
endmacro(is_enabled)

function(set_nds_protocols variable TEST_NAME)
    string(REPLACE "_" ";" name_list ${TEST_NAME})
    list(SORT name_list)
    list(REMOVE_DUPLICATES name_list)
    list(REMOVE_ITEM name_list "")
    ## message(STATUS "DEBUG: set_nds_protocols: name_list: ${name_list}")

    list(FIND name_list nds1 _index)
    if (${_index} GREATER -1)
        set(protocol_list ${NDS_TESTING_PROTOCOLS_NDS1})
    endif (${_index} GREATER -1)

    list(FIND name_list nds2 _index)
    if (${_index} GREATER -1)
        set(protocol_list ${NDS_TESTING_PROTOCOLS_NDS2})
    endif (${_index} GREATER -1)
    list(LENGTH protocol_list len)
    if ( NOT DEFINED protocol_list )
        message(FATAL_ERROR "Unable to determine NDS protocol for test ${TEST_NAME}")
    endif ( NOT DEFINED protocol_list )
    ## message(STATUS "DEBUG: set_nds_protocols: protocol_list: ${protocol_list}")
    set(${variable} ${protocol_list} PARENT_SCOPE)
endfunction(set_nds_protocols)

macro( unquote VAR )
    #--------------------------------------------------------------------
    # Removes outer most level of quotation.
    #--------------------------------------------------------------------
    string( STRIP "${${VAR}}" ${VAR} )
    string( REGEX REPLACE "^\"(.*)\"$" "\\1" ${VAR} ${${VAR}} )
endmacro( unquote VAR )

function( verify_release_info filename pattern )
    #--------------------------------------------------------------------
    # verifies that file has string pattern for release.
    #--------------------------------------------------------------------
    file(READ ${filename} buffer)
    string( FIND "${buffer}" ${pattern} matchres )
    if( ${matchres} EQUAL -1 )
        message( FATAL_ERROR "File: ${filename} has not been updated for release ${pattern}" )
    else( )
        message( STATUS "File: ${filename} has been updated for release ${pattern}" )
    endif( )
endfunction( )

#========================================================================
# Release version number
#========================================================================
set( PACKAGE_NAME ${PROJECT_NAME} )
set( PACKAGE_VERSION ${${PROJECT_NAME}_VERSION} )

# The following line is an input marker for some sed work when doing a
# CI build, it is used to inject an updated version tag when building
# a deb/rep/...  so it is only used on a copy of this file.
##CI_code_version_update

verify_release_info( "${CMAKE_SOURCE_DIR}/ChangeLog" "${PROJECT_NAME}-${PROJECT_VERSION}")
verify_release_info( "${CMAKE_SOURCE_DIR}/debian/changelog" "${PROJECT_NAME} (${PROJECT_VERSION}-1)")

#========================================================================
# Prepare for testing
#========================================================================

if ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS1 )
    set( NDS_TESTING_PROTOCOLS_NDS1
        nds1-12_2 )
endif ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS1 )
if ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS2 )
    set( NDS_TESTING_PROTOCOLS_NDS2
        nds2-1_6 nds2-1_5 )
endif ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS2 )
if ( DEFINED CTEST_TESTING_TIMEOUT )
    set( CTEST_TESTING_TIMEOUT 60 )
endif ( DEFINED CTEST_TESTING_TIMEOUT )

if( NOT CTEST_MEMORYCHECK_COMMAND )
    find_program( CTEST_MEMORYCHECK_COMMAND NAMES valgrind )
endif( NOT CTEST_MEMORYCHECK_COMMAND )
if( NOT MEMORYCHECK_COMMAND )
    set( MEMORYCHECK_COMMAND ${CTEST_MEMORYCHECK_COMMAND} )
endif( NOT MEMORYCHECK_COMMAND )

if( NOT CTEST_MEMORYCHECK_COMMAND_OPTIONS )
    set( CTEST_MEMORYCHECK_COMMAND_OPTIONS "--trace-children=yes --leak-check=full" )
endif( NOT CTEST_MEMORYCHECK_COMMAND_OPTIONS )
if( NOT MEMORYCHECK_COMMAND_OPTIONS )
    set( MEMORYCHECK_COMMAND_OPTIONS ${CTEST_MEMORYCHECK_COMMAND_OPTIONS} )
endif( NOT MEMORYCHECK_COMMAND_OPTIONS )


include( CTest )


find_package(
    NDSTester 0.15.3 REQUIRED
    HINTS ${nds2-client_DIR} )
set( NDS_TESTER_FOUND ${NDSTester_FOUND} )

if ( NDS_TESTER_FOUND )
    set(NDS_TESTER_FLAGS
        "--builddir=\${CMAKE_CURRENT_BINARY_DIR}"
        "--abs-top-srcdir=${CMAKE_SOURCE_DIR}"
        "--abs-srcdir=\${CMAKE_CURRENT_SOURCE_DIR}"
        "--abs-top-builddir=${CMAKE_BINARY_DIR}"
        "--abs-testerdir=${ABS_TESTERDIR}"
        )
endif()

# message( FATAL_ERROR "DEBUG: NDS_TESTER_FOUND: ${NDS_TESTER_FOUND}" )

#========================================================================
# Prepare for distribuition
#========================================================================
#   G e n e r a l
#------------------------------------------------------------------------
set( CPACK_PACKAGE_VENDOR "LIGO" )
set( CPACK_PACKAGE_MAJOR ${${PROJECT_NAME}_MAJOR_VERSION} )
set( CPACK_PACKAGE_MINOR ${${PROJECT_NAME}_MINOR_VERSION} )
set( CPACK_PACKAGE_PATCH ${${PROJECT_NAME}_PATCH_VERSION} )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "Client interface to NDS and NDS2 servers" )
set( CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_MAJOR}.${CPACK_PACKAGE_MINOR}.${CPACK_PACKAGE_PATCH}" )
#------------------------------------------------------------------------
#   S O U R C E
#------------------------------------------------------------------------
set( CPACK_SOURCE_GENERATOR TBZ2 )
set( CPACK_SOURCE_PACKAGE_FILE_NAME
     ${PROJECT_NAME}-${${PROJECT_NAME}_VERSION} )
#set( CPACK_SYSTEM_NAME noarch )
set( CPACK_SOURCE_IGNORE_FILES "/.*~$/;/(CVS|autom4te[.]cache)/;/[.]svn/;[.]swap$;[.]#;.*~$;cscope.*")

include(CPack)

cpack_add_component_group(Runtime
                          DESCRIPTION "Pieces needed for running")

#========================================================================
# Find import pieces
#========================================================================

find_package(SWIG 3.0.7 REQUIRED)
include(${SWIG_USE_FILE})

message( STATUS "DEBUG: NDS_CLIENT_LIBRARIES: ${NDS_CLIENT_LIBRARIES}" )
message( STATUS "DEBUG: NDS_CLIENT_CFLAGS: ${NDS_CLIENT_CFLAGS}" )
message( STATUS "DEBUG: NDS_CLIENT_INCLUDE_DIRS: ${NDS_CLIENT_INCLUDE_DIRS}" )

#========================================================================
# Get the default python interpreter for testing purposes
#========================================================================

cx_python( PREFIX PYTHON_DFLT )
find_program( PROG_MATLAB matlab )

#========================================================================
# Handle the target languages
#========================================================================

set( SUBPORTS
    ${PROJECT_BASENAME}-java
    ${PROJECT_BASENAME}-matlab
    # ${PROJECT_BASENAME}-octave
    py27-${PROJECT_BASENAME}
    py34-${PROJECT_BASENAME}
    py35-${PROJECT_BASENAME}
    py36-${PROJECT_BASENAME}
    )

add_subdirectory(common)
add_subdirectory(python)
add_subdirectory(java)
add_subdirectory(octave)

add_subdirectory(matlab)

#========================================================================
# Generation of documentation
#========================================================================

find_package(Doxygen)

if(DOXYGEN_FOUND)
  configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/manual.txt.in
      ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
      @ONLY )
  #--------------------------------------------------------------------
  # User documentation
  #--------------------------------------------------------------------
  cx_target_manual(
    TARGET User
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/NDSClientDoc.cfg.in
    ENABLE_SECTIONS "USER_SECTION"
    MAIN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
    HIDE_UNDOC_MEMBERS
    HIDE_UNDOC_CLASSES
    EXCLUDE_PATTERNS */sqlite3.* */test/* */CMakeLists.txt *.in
    )
  cx_target_manual(
    TARGET Developer
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/NDSClientDoc.cfg.in
    ENABLE_SECTIONS "DEVELOPER_SECTION"
    MAIN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
    EXTRACT_ALL
    EXTRACT_PRIVATE
    EXTRACT_STATIC
    EXTRACT_LOCAL_CLASSES
    EXTRACT_LOCAL_METHODS
    EXTRACT_ANON_NSPACES
    EXCLUDE_PATTERNS */sqlite3.* */test/* */CMakeLists.txt *.in
    )
  cx_target_manual(
    TARGET Administrator
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/NDSClientDoc.cfg.in
    ENABLE_SECTIONS "ADMIN_SECTION"
    MAIN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
    HIDE_UNDOC_MEMBERS
    HIDE_UNDOC_CLASSES
    EXCLUDE_PATTERNS */sqlite3.* */test/* */CMakeLists.txt *.in
    )
endif(DOXYGEN_FOUND)

#========================================================================
# Provide additional information regarding components
#========================================================================
cpack_add_component(Development
    DISPLAY_NAME "SWIG  extensions"
    DESCRIPTION
        "Pieces needed to build extensions to the nds2 client using SWIG"
        )

#========================================================================
# Testing of the packaging
#========================================================================
set( AX_SOURCE_SPEC_FILENAME "${NDS_CONFIG_PATH}/${PROJECT_NAME}.spec.in" )
ax_packaging( )

if ( MACPORTSBUILD )
    add_dependencies(
        macports-subport-${PROJECT_BASENAME}-matlab
        macports-subport-${PROJECT_BASENAME}-java )
endif( )
#========================================================================
# Save command line to file for later rebuilding
#========================================================================
get_cmake_property(CACHE_VARS CACHE_VARIABLES)
foreach(CACHE_VAR ${CACHE_VARS})
  get_property(CACHE_VAR_HELPSTRING CACHE ${CACHE_VAR} PROPERTY HELPSTRING)
  if(CACHE_VAR_HELPSTRING STREQUAL "No help, variable specified on the command line.")
    get_property(CACHE_VAR_TYPE CACHE ${CACHE_VAR} PROPERTY TYPE)
    if(CACHE_VAR_TYPE STREQUAL "UNINITIALIZED")
      set(CACHE_VAR_TYPE)
    else()
      set(CACHE_VAR_TYPE :${CACHE_VAR_TYPE})
    endif()
    set(CMAKE_ARGS "${CMAKE_ARGS} -D${CACHE_VAR}${CACHE_VAR_TYPE}=\"${${CACHE_VAR}}\"")
  endif()
endforeach()
set(USED_CMD_LINE "${CMAKE_COMMAND} ${CMAKE_ARGS} ${CMAKE_SOURCE_DIR}")
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/config.status ${USED_CMD_LINE} )
#========================================================================
# Report configuration information
#  CMAKE_MAKE_PROGRAM:FILEPATH

=== common/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
find_package(SWIG 2.0.4 REQUIRED)

#========================================================================
# Discover if JAVA is available and usable
#========================================================================
add_subdirectory(module)
# add_subdirectory(test)

=== java/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
find_package(SWIG 2.0.4 REQUIRED)

#========================================================================
# Discover if JAVA is available and usable
#========================================================================
find_package(Java)
find_package(JNI)

if ( JAVA_FOUND AND JNI_FOUND )

    #--------------------------------------------------------------------
    # Since it is available and usable, finish up with making it
    #   usable
    #--------------------------------------------------------------------
    include(UseJava)
    set( ENABLE_SWIG_JAVA "yes"
        CACHE INTERNAL "Control the building of the SWIG bindings for Java" )

    if ( ${Java_VERSION_STRING} GREATER "1.8"  )
        set( NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH "" )
    else ( ${Java_VERSION_STRING} GREATER "1.8"  )
        if ( UNIX AND NOT APPLE )
            execute_process(
                COMMAND ${Java_JAVA_EXECUTABLE} -XshowSettings:properties -help
                OUTPUT_QUIET
                ERROR_VARIABLE _PROPERTIES
                )
            # message( STATUS "DEBUG: Setting JAVA PROPERTIES to: ${Java_JAVA_EXECUTABLE}" ${_PROPERTIES} )
            string( REGEX MATCH "sun.boot.library.path = [^\n]*"
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH
                ${_PROPERTIES} )
            string( REPLACE "sun.boot.library.path = " ""
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
            string( STRIP
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH )
            file( TO_CMAKE_PATH
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH )
            set( NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH
                "LD_LIBRARY_PATH=${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}/xawt" )
            message( STATUS "DEBUG: Setting JAVA LIB to: ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}" )
        endif ( UNIX AND NOT APPLE )
    endif ( ${Java_VERSION_STRING} GREATER "1.8"  )
endif( JAVA_FOUND
    AND JNI_FOUND)

add_subdirectory(module)
add_subdirectory(test)

#========================================================================
# Provide additional information regarding components
#========================================================================

cpack_add_component(JAVA
    DISPLAY_NAME "JAVA extensions"
    DESCRIPTION
        "Pieces needed to use the nds2 client from JAVA"
    GROUP Runtime)

=== matlab/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

set( ENABLE_SWIG_MATLAB "YES"
    CACHE INTERNAL "Control the building of MATLAB extensions" )

add_subdirectory(module)
add_subdirectory(test)

#========================================================================
# Provide additional information regarding components
#========================================================================

cpack_add_component(MATLAB
    DISPLAY_NAME "MATLAB extensions"
    DESCRIPTION
        "Pieces needed to use the nds2 client from MATLAB"
    GROUP Runtime
    DEPENDS JAVA
    )

=== octave/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

#========================================================================
# Discover if Octave is available and usable
#========================================================================
find_package(HDF5)
find_package(Octave)

if (OCTAVE_FOUND AND SWIG_FOUND)

  set( OCTAVE_VERSION_STRING ${OCTAVE_VERSION_STRING} PARENT_SCOPE )

  set( ENABLE_SWIG_OCTAVE "yes"
       CACHE INTERNAL "Control the building of the SWIG bindings for Octave" )
  find_library( OCTAVE_OCTAVE_LIBRARY
                NAMES octave
		HINTS ${OCTAVE_LINK_DIRS} )
  find_library( OCTAVE_INTERP_LIBRARY
                NAMES octinterp
		HINTS ${OCTAVE_LINK_DIRS} )
  set( OCTAVE_LIBRARIES
       ${OCTAVE_INTERP_LIBRARY}
       ${OCTAVE_OCTAVE_LIBRARY} )

endif(OCTAVE_FOUND AND SWIG_FOUND)

add_subdirectory(module)
add_subdirectory(test)

#========================================================================
# Provide additional information regarding components
#========================================================================

cpack_add_component(Octave
    DISPLAY_NAME "Octave extensions"
    DESCRIPTION
        "Pieces needed to use the nds2 client from Octave"
    GROUP Runtime)

=== common/module/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
include(UseCopyIfDifferent)

configure_file(nds_swig_version.hh.in ${CMAKE_CURRENT_BINARY_DIR}/nds_swig_version.hh @ONLY)

set( nds_hdrs
    nds_swig.hh
    ${CMAKE_CURRENT_BINARY_DIR}/nds_swig_version.hh
    )
set( SWIG_SOURCES
    nds.i
    nds_availability.i
    nds_buffer.i
    nds_channel.i
    nds_connection.i
    nds_epoch.i
    nds_version.i
    )
install(
    FILES ${SWIG_SOURCES} ${nds_hdrs}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_BASENAME}
    COMPONENT Development
    )

=== common/test/CMakeLists.txt ===
# -*- conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
function(standalone_test name command)
    if( WIN32 )
        set(CMD_PATH ${EXECUTABLE_OUTPUT_PATH})
    else( WIN32 )
        set(CMD_PATH ${CMAKE_CURRENT_BINARY_DIR})
    endif( WIN32 )

    add_executable(${command} ${command}.cc)
    #target_include_directories(${command} ${test_includes})
    target_link_libraries(${command} ndswrapcxx)
    add_test(
        NAME ${name}
        COMMAND
            "${CMD_PATH}/${command}"
    )
    set_tests_properties( ${name}
        PROPERTIES
            SKIP_RETURN_CODE 77
            TIMEOUT 180
    )
endfunction(standalone_test)
function(build_test command)
    add_executable(${command} ${command}.cc)
    #target_include_directories(${command} ${test_includes})
    target_link_libraries(${command} ndswrapcxx)
endfunction(build_test)
#------------------------------------------------------------------------
# Final variable substitution before use
#------------------------------------------------------------------------
string(CONFIGURE "${NDS_TESTER_FLAGS}" NDS_TESTER_FLAGS )
set(test_names)
set(test_includes PUBLIC
    "${CMAKE_BINARY_DIR}/src/libndscxx/module"
    "${CMAKE_SOURCE_DIR}/src/libndscxx/module"
    "${CMAKE_BINARY_DIR}/src/client"
    "${CMAKE_SOURCE_DIR}/src/client"
)
#------------------------------------------------------------------------
# Set the test includes.  When we move off of cmake 2.8.x use
# target_include_directories instead
#------------------------------------------------------------------------
include_directories(${test_includes})
#------------------------------------------------------------------------
standalone_test(_cxx_is-trend-type_ test_is_trend_type_cxx)
standalone_test(_cxx_gap-composer_ test_gap_composer_cxx)
standalone_test(_cxx_gap-handlers_ test_gap_handlers_cxx)
standalone_test(_cxx_nds2_version_ test_nds2_version_cxx)
standalone_test(_cxx_buffer_iterator_ test_buffer_iterator_cxx)
standalone_test(_cxx_buffer_creation_ test_buffer_creation_and_access_cxx)
standalone_test(_cxx_parameter_block_ test_parameter_block_cxx)
#------------------------------------------------------------------------
if( PYTHON_EXECUTABLE )
    function(mock_server_test name command)
        add_executable(${command} ${command}.cc)
        #target_include_directories(${command} ${test_includes})
        target_link_libraries(${command} ndswrapcxx)
        add_test(
            NAME ${name}
            COMMAND
                "${PYTHON_EXECUTABLE}" "${PROG_NDS_TESTER}" ${NDS_TESTER_FLAGS}
                --nds1-mock-server
                "$<TARGET_FILE:${command}>" )
        set_tests_properties( ${name}
            PROPERTIES
                SKIP_RETURN_CODE 77
                TIMEOUT 180 )
        set( NDS_CUSTOM_MEMCHECK_IGNORE
            ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
            CACHE INTERNAL "" )
    endfunction(mock_server_test)
    function(replay_server_test name command json)
        build_test( ${command} )
        replay_server_test_nobuild( ${name} ${command} ${json} ${ARGN} )
    endfunction(replay_server_test)
    function(replay_server_test_nobuild name command json)
        if( WIN32 )
            set(CMD_PATH ${EXECUTABLE_OUTPUT_PATH})
        else( WIN32 )
            set(CMD_PATH ${CMAKE_CURRENT_BINARY_DIR})
        endif( WIN32 )
        if ( REPLAY_BLOB_CACHE_DIR )
            set_nds_protocols(protocols ${name})
            foreach ( proto ${protocols} )
                set(test_name "${name}${proto}_")
                add_test(
                    NAME ${test_name}
                    COMMAND
                    	${PROG_ENV} "REPLAY_BLOB_REMOTE_CACHE=${REPLAY_BLOB_CACHE_DIR}"
                        "${PYTHON_EXECUTABLE}" "${PROG_NDS_TESTER}" ${NDS_TESTER_FLAGS}
                        --replay-server
                        --replay-json-filename ${json}
                        --replay-protocol ${proto}
                        "$<TARGET_FILE:${command}>" ${ARGN} )
                set_tests_properties( ${test_name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        TIMEOUT 180 )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${test_name}
                    CACHE INTERNAL "" )
            endforeach ( proto )
        endif ( REPLAY_BLOB_CACHE_DIR )
    endfunction(replay_server_test_nobuild)
    #====================================================================
    # These tests require a minimum of Python
    #====================================================================
    mock_server_test(_cxx_mockup_ test_mockup_cxx)
    #--------------------------------------------------------------------
    build_test(test_fetch_cxx)
    replay_server_test_nobuild(
            _cxx_nds2_fetch_
            test_fetch_cxx
            lho-prod.json)
    #--------------------------------------------------------------------
    build_test(test_timeout_cxx)
    replay_server_test_nobuild(
        _cxx_nds1_timeout_
        test_timeout_cxx
        nds1-timeout.json
        -proto-1)
    replay_server_test_nobuild(
        _cxx_nds2_timeout_
        test_timeout_cxx
        nds2-timeout.json
        -proto-2 )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds2_availability_
        test_nds2_availability_cxx
        nds2-availability.json )
    #--------------------------------------------------------------------
    #replay_server_test(
    #    _cxx_nds1_basic-gap_
    #    test_nds1_basic_gap_cxx
    #    nds1-basic_gap_multi.json
    #    -multi )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds1_get-epochs_
        test_get_epochs_cxx
        nds1-get-epoch.json -proto-1 )
    #--------------------------------------------------------------------
    replay_server_test(
            _cxx_nds2_one-second-channel-list_
            test_nds2_one-second-channel-list_cxx
            nds2-one_second_channel_list.json )
    #--------------------------------------------------------------------
    build_test( test_nds2_dissimilar_gaps_cxx )
    replay_server_test_nobuild(
        _cxx_nds2_dissimilar-gaps_
        test_nds2_dissimilar_gaps_cxx
        nds2-dissimilar_gaps.json )
    #--------------------------------------------------------------------
    replay_server_test(
            _cxx_nds2_iterate_no_data_
            test_nds2_iterate_no_data_cxx
            nds2-iterate_with_no_data.json
    )
    build_test( test_iterate_with_gaps_cxx )
    replay_server_test_nobuild(
        _cxx_nds1_iterate-with-gaps_
        test_iterate_with_gaps_cxx
        nds1-iterate_with_leading_gap.json
        -proto-1 )
    replay_server_test_nobuild(
        _cxx_nds2_iterate-with-gaps_
        test_iterate_with_gaps_cxx
        nds2-iterate_with_leading_gap.json
        -proto-2 )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds1_restart_failure_
        test_nds1_restart_failure_cxx
        nds1-restart-failure.json
    )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds2_get-last-message_
        test_nds2_get_last_message_cxx
        nds2-get-last-message.json )
    #--------------------------------------------------------------------
    build_test( test_nds_count_channels_cxx )
    replay_server_test_nobuild(
        _cxx_nds1_count-channels_
        test_nds_count_channels_cxx
        nds1-count-channels-synthetic.json
        -proto-1 )
    replay_server_test_nobuild(
        _cxx_nds2_count-channels_
        test_nds_count_channels_cxx
        nds2-count-channels-synthetic.json
        -proto-2 )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds2_ticket-169_
        test_ticket_169_cxx
        nds2-ticket-169.json )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds2_ticket-246_
        test_ticket_246_cxx
        nds2-ticket-246.json )
    #--------------------------------------------------------------------
    replay_server_test(
            _cxx_nds2_test_ticket-260_
            test_ticket_260_cxx
            nds2-ticket-260.json
    )
    #--------------------------------------------------------------------
    build_test( test_nds_ticket_282_cxx )
    replay_server_test_nobuild(
            _cxx_nds1_ticket-282_cxx_
            test_nds_ticket_282_cxx
            nds1-ticket-282.json
            -proto-1
    )
    #--------------------------------------------------------------------
    replay_server_test(
        _cxx_nds2_test_ticket-288_
        test_ticket_288_cxx
        nds2-ticket-288.json
    )
    #--------------------------------------------------------------------
    replay_server_test(
            _cxx_nds2_ticket-289_
            test_nds2_ticket_289_cxx
            nds2-ticket-289.json
    )
    #--------------------------------------------------------------------
    build_test( test_nds_iterate_all_data_cxx )
    replay_server_test_nobuild(
            _cxx_nds2_iterate-all-data_
            test_nds_iterate_all_data_cxx
            nds2-iterate-all-data-synthetic.json
            -proto-2
    )
    replay_server_test_nobuild(
            _cxx_nds2_iterate-all-data-nogaphandler_
            test_nds_iterate_all_data_cxx
            nds2-iterate-all-data-synthetic.json
            -proto-2 -no-gap
    )
    replay_server_test_nobuild(
            _cxx_nds1_iterate-all-data_
            test_nds_iterate_all_data_cxx
            nds1-iterate-all-data-synthetic.json
            -proto-1
    )
    replay_server_test_nobuild(
            _cxx_nds1_iterate-all-data-nogaphandler_
            test_nds_iterate_all_data_cxx
            nds1-iterate-all-data-synthetic.json
            -proto-1 -no-gap
    )
    #--------------------------------------------------------------------
    build_test( test_nds_iterate_out_of_scope_cxx )
    replay_server_test_nobuild(
            _cxx_nds2_iterate_out_of_scope_
            test_nds_iterate_out_of_scope_cxx
            nds2-iterate-all-data-synthetic-no-followup.json
    )
    #--------------------------------------------------------------------
    build_test( test_nds_iterate_with_synth_gaps_cxx )
    replay_server_test_nobuild(
            _cxx_nds1_iterate-with-synth-gaps_
            test_nds_iterate_with_synth_gaps_cxx
            nds1-iterate-with-gaps-synthetic.json
            -proto-1
    )
    replay_server_test_nobuild(
            _cxx_nds1_iterate-with-synth-gaps-nogaphandler_
            test_nds_iterate_with_synth_gaps_cxx
            nds1-iterate-with-gaps-synthetic.json
            -proto-1 -no-gap
    )
    replay_server_test_nobuild(
            _cxx_nds1_iterate-with-synth-gaps-defaultgaphandler_
            test_nds_iterate_with_synth_gaps_cxx
            nds1-iterate-with-gaps-synthetic.json
            -proto-1 -default-gap-handling
    )
    #--------------------------------------------------------------------
    build_test( test_nds_iterate_live_data_bounded_cxx )
    replay_server_test_nobuild(
            _cxx_nds2_iterate-live-data-bounded_
            test_nds_iterate_live_data_bounded_cxx
            nds2-iterate-live-data-bounded-synthetic.json
            -proto-2
    )
    replay_server_test_nobuild(
            _cxx_nds1_iterate-live-data-bounded_
            test_nds_iterate_live_data_bounded_cxx
            nds1-iterate-live-data-bounded-synthetic-multiconn.json
            -proto-1
    )
    #--------------------------------------------------------------------
    build_test( test_nds_iterate_live_data_cxx )
    replay_server_test_nobuild(
            _cxx_nds2_iterate-live-data_

=== java/module/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
cmake_minimum_required(VERSION 2.8.6)

if ( ENABLE_SWIG_JAVA )
    file( GLOB CONLIBNDSCXX_OBJECTS ${CONLIBNDSCXX_LIBRARY_DIRS}/* )

    function(SET_NDS_JAVA_LIBRARY_DIR BUILD_TYPE)
        if (WIN32)
            string(TOUPPER ${BUILD_TYPE} BUILD_TYPE_UPPER)
            set( NDS_LIBRARY_DIR $ENV{PATH} )
            list( INSERT NDS_LIBRARY_DIR 0 "${CMAKE_BINARY_DIR}/bin/${BUILD_TYPE}" )
            set( TMP_NDS_LIBRARY_DIR "" )
            foreach( TMP ${NDS_LIBRARY_DIR} )
                file( TO_NATIVE_PATH ${TMP} TMP )
                string( REPLACE "\\" "\\\\" TMP ${TMP} )
                string( LENGTH "${TMP_NDS_LIBRARY_DIR}" L )
                if( $L LESS 1 )
                    set( TMP_NDS_LIBRARY_DIR ${TMP} )
                else( $L LESS 1 )
                    set( TMP_NDS_LIBRARY_DIR "${TMP_NDS_LIBRARY_DIR}\\\\;${TMP}" )
                endif( $L LESS 1 )
            endforeach( TMP )
            #join( ${TMP_NDS_LIBRARY_DIR} ";" NDS_LIBRARY_DIR )
            set( NDS_LIBRARY_DIR ${TMP_NDS_LIBRARY_DIR} )
            #get_target_property( NDS_LIBRARY_DIR nds2JNI LIBRARY_OUTPUT_DIRECTORY )
            set(BUILD_TYPE_UPPER "_${BUILD_TYPE_UPPER}")
        else (WIN32)
            set(BUILD_TYPE_UPPER "")
            get_target_property( NDS_LIBRARY_DIR nds2 LIBRARY_OUTPUT_DIRECTORY )
        endif(WIN32)
        set( NDS_LIBRARY${BUILD_TYPE_UPPER}_DIR "${NDS_LIBRARY_DIR}"
            CACHE INTERNAL "Internal" )
        set( NDS_LIBRARY_DIR "${NDS_LIBRARY_DIR}"
            CACHE INTERNAL "Internal" )
    endfunction(SET_NDS_JAVA_LIBRARY_DIR )

    set(NDS2_JAR_PACKAGING FALSE
        CACHE PATH "True if the Java bindings should be distributed as a jar file." )


    include_directories( BEFORE
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${PROJECT_BINARY_DIR}/common/module
        ${PROJECT_SOURCE_DIR}/common/module
        ${nds2-client_INCLUDE_DIRS}
        ${JNI_INCLUDE_PATH}
        ${JAVA_INCLUDE_PATH}
        ${JAVA_INCLUDE_PATH2}
        )
    include_directories(AFTER "/usr/include")


    set(INTERFACE_FILE "nds_java.i")
    set(WRAPPER_FILE "nds2_wrap.cc")
    set(CMAKE_JNI_TARGET true)
    set(built_java_sources
        nds2/availability.java
        nds2/availability_list_type.java
        nds2/availabilityListType.java
        nds2/buffer.java
	      nds2/channel.java
        nds2/channel_names_type.java
	      nds2/connection.java
	      nds2/connection_iterator.java
        nds2/epoch.java
        nds2/epochs_type.java
        nds2/nds2.java
        nds2/segment.java
        nds2/segment_list_type.java
        nds2/simple_availability_list_type.java
        nds2/simple_segment.java
        nds2/simple_segment_list_type.java
        nds2/SWIGTYPE_p_channel__hash_type.java
        nds2/vectorEpochs.java
        nds2/vectorSegment.java
        nds2/vectorSimpleSegment.java
        nds2/vectorSimpleSegmentListType.java
        nds2/channel_predicate.java
        nds2/request_period.java
        nds2/parameters.java
	      nds2/nds2JNI.java)
    set(built_java_classes "")
    set(pathed_built_java_sources "")
    foreach(_NDS_FILE ${built_java_sources})
        string(REGEX REPLACE "^nds2/" ""
            _built_java_class ${_NDS_FILE})
        string(REGEX REPLACE ".java$" ".class"
            _built_java_class ${_built_java_class})
        set(built_java_classes ${built_java_classes} ${_built_java_class})
        set( pathed_built_java_sources
            ${pathed_built_java_sources}
            "${CMAKE_CURRENT_BINARY_DIR}/${_NDS_FILE}" )
    endforeach(_NDS_FILE ${built_java_sources})

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/nds2/connection_iterator.java
                COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/connection_iterator.java ${CMAKE_CURRENT_BINARY_DIR}/nds2/connection_iterator.java
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            )

    set(CMAKE_SWIG_FLAGS -O -package nds2)
    set(CMAKE_SWIG_OUTDIR nds2)
    set_property(SOURCE ${INTERFACE_FILE} PROPERTY CPLUSPLUS ON)
    message( STATUS "Java_VERSION_MAJOR: ${Java_VERSION_MAJOR}")
    set(CMAKE_JAVA_COMPILE_FLAGS -source 1.6 -target 1.6 )
    set(_build_java_sources_cmd "")

    set_source_files_properties(${WRAPPER_FILE} PROPERTIES GENERATED true)
    set(CMAKE_JAVAC_WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    set(CMAKE_JAVA_CLASS_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/nds2)
    set_source_files_properties(${built_java_sources} PROPERTIES GENERATED true)

    # -------------------------------------------------------------------
    # swig_add_module(nds2JNI java ${INTERFACE_FILE})
    # -------------------------------------------------------------------
    add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${WRAPPER_FILE}"
        DEPENDS
        COMMAND ${CMAKE_COMMAND}
        ARGS    -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SWIG_OUTDIR}
        COMMAND ${SWIG_EXECUTABLE}
        ARGS    -java -c++ ${CMAKE_SWIG_FLAGS}
                -I${CMAKE_CURRENT_BINARY_DIR}
                -I${CMAKE_CURRENT_SOURCE_DIR}
                -I${PROJECT_BINARY_DIR}/common/module
                -I${PROJECT_SOURCE_DIR}/common/module
                -o ${WRAPPER_FILE}
                -outdir ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SWIG_OUTDIR}
                ${INTERFACE_FILE}
    )
    # -------------------------------------------------------------------
    # swig_link_libraries(nds2JNI -static-libstdc++ ${JNI_LIBRARIES} $<TARGET_OBJECTS:ndswrapcxx_obj> ndsclient)
    # -------------------------------------------------------------------
    add_library( nds2JNI SHARED
        "${CMAKE_CURRENT_BINARY_DIR}/${WRAPPER_FILE}"
    )
    target_link_libraries( nds2JNI
        -static-libstdc++
        ${CONLIBNDSCXX_OBJECTS}
        ${JNI_LIBRARIES}
        nds::daqc
    )
    if( WIN32 )
        target_link_libraries( nds2JNI nds::cxx Ws2_32 )
    endif( WIN32 )

    target_requires_cpp11(nds2JNI PUBLIC)
    if ( APPLE )
        swig_add_library(nds2JNI_rpath LANGUAGE java SOURCES ${INTERFACE_FILE})
        swig_link_libraries(nds2JNI_rpath ${JNI_LIBRARIES} nds::cxx)
    endif ( APPLE )
    if (WIN32)
        #................................................................
        # Windows
        #................................................................
        add_custom_command(TARGET nds2JNI POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE_DIR:nds2JNI>/$<TARGET_FILE_NAME:nds2JNI> ${CMAKE_CURRENT_BINARY_DIR}/libnds2JNI.jnilib)
    else (WIN32)
        #................................................................
        # Un*x / OSX
        #................................................................
        set_target_properties(nds2JNI
    	    PROPERTIES
            LIBRARY_OUTPUT_DIRECTORY nds2
    	    PREFIX lib
    	    SUFFIX .jnilib)
        if ( APPLE )
            set_target_properties(nds2JNI_rpath
    	        PROPERTIES
                    BUILD_WITH_INSTALL_RPATH TRUE
                    LIBRARY_OUTPUT_DIRECTORY rpath/nds2
                    OUTPUT_NAME nds2JNI
    	            PREFIX lib
    	            SUFFIX .jnilib)
        endif ( APPLE )
    endif(WIN32)

    #--------------------------------------------------------------------
    # Build the JAR library
    #--------------------------------------------------------------------
    message("################################ built_java_sources = ${built_java_sources}")
    add_jar(nds2 ${built_java_sources})
    add_dependencies(nds2 nds2JNI)
    if ( APPLE )
        add_jar(nds2_rpath ${built_java_sources})
        add_dependencies(nds2_rpath nds2JNI_rpath)
    endif ( APPLE )
    #--------------------------------------------------------------------
    # Build java documentation
    #--------------------------------------------------------------------
    if( NOT WIN32 )
    create_javadoc(
        nds2
        FILES ${pathed_built_java_sources}
        CLASSPATH ${CMAKE_JAVA_INCLUDE_PATH}
        INSTALLPATH ${CMAKE_INSTALL_DATADIR}/nds2-client/java
        WINDOWTITLE "NDS2 Client Interface"
        DOCTITLE "<h1>NDS2 Client Interface</h1>"
        AUTHOR TRUE
        USE TRUE
        VERSION TRUE
    )
    add_dependencies( nds2_javadoc nds2 )
    endif( NOT WIN32 )

    #--------------------------------------------------------------------
    # Create JAR of documentation
    #--------------------------------------------------------------------
    if( NOT WIN32 )
    add_custom_target(nds2_javadoc_jar
        ALL
        COMMAND ${CMAKE_COMMAND} -E echo ${JAVA_ARCHIVE} -cvf ${CMAKE_CURRENT_BINARY_DIR}/nds2_javadoc.jar "."
    	COMMAND ${JAVA_ARCHIVE} -cvf ${CMAKE_CURRENT_BINARY_DIR}/nds2_javadoc.jar "."
    	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/javadoc/nds2"
    	DEPENDS nds2_javadoc)
    endif( NOT WIN32 )
    #--------------------------------------------------------------------
    # Add the JNI library to the jar archive
    #--------------------------------------------------------------------
    add_custom_target(nds2JNIinclusion
        ALL
        COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE_DIR:nds2JNI>/$<TARGET_FILE_NAME:nds2JNI> "${CMAKE_CURRENT_BINARY_DIR}/nds2"
    	COMMAND ${JAVA_ARCHIVE} uvf ${CMAKE_CURRENT_BINARY_DIR}/nds2.jar "nds2/$<TARGET_FILE_NAME:nds2JNI>"
    	DEPENDS nds2)
    if ( APPLE )
        add_custom_target(nds2JNIinclusion_rpath
            ALL
            COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/rpath/nds2/"
            COMMAND ${CMAKE_COMMAND} -E copy
                $<TARGET_FILE_DIR:nds2JNI_rpath>/$<TARGET_FILE_NAME:nds2JNI_rpath> "${CMAKE_CURRENT_BINARY_DIR}/rpath/nds2"
    	    COMMAND ${JAVA_ARCHIVE} uvf ${CMAKE_CURRENT_BINARY_DIR}/nds2_rpath.jar -C "${CMAKE_CURRENT_BINARY_DIR}/rpath" "nds2/$<TARGET_FILE_NAME:nds2JNI_rpath>"
    	        DEPENDS nds2_rpath)
        set( FILENAME_NDS2_JAR "${CMAKE_CURRENT_BINARY_DIR}/nds2_rpath.jar" )
    else ( APPLE )
        set( FILENAME_NDS2_JAR "${CMAKE_CURRENT_BINARY_DIR}/nds2.jar" )
    endif ( APPLE )
    #====================================================================
    # Report the configuration
    #====================================================================
    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/nds2-client-java.cfg.in
        ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-java.cfg
	@ONLY )
    #====================================================================
    # Distribution rules
    #====================================================================
    if( NOT WIN32)
        install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-java.cfg
            DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${PROJECT_BASENAME}
            COMPONENT JAVA
            )
    endif( NOT WIN32)

    install(
        FILES "${FILENAME_NDS2_JAR}"
        RENAME "nds2.jar"
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/nds2-client/java
	COMPONENT JAVA
    )
    if ( NOT WIN32 )
        install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/nds2_javadoc.jar
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/nds2-client/java
            COMPONENT JAVA
        )
    endif ( NOT WIN32 )
    foreach(_NDS_FILE ${built_java_classes})
	install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/nds2.dir/nds2/${_NDS_FILE}
	    DESTINATION ${CMAKE_INSTALL_LIBDIR}/nds2-client/java/nds2
	    COMPONENT JAVA)
    endforeach(_NDS_FILE)

    install(TARGETS nds2JNI
	    DESTINATION ${CMAKE_INSTALL_LIBDIR}/java/nds2
	    COMPONENT JAVA)
    if (WIN32)
      install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libnds2JNI.jnilib
	  DESTINATION ${CMAKE_INSTALL_LIBDIR}/java/nds2
          COMPONENT JAVA)
    endif(WIN32)
    
    set_nds_java_library_dir( "Release" )

=== java/test/CMakeLists.txt ===
# -*- conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

macro(set_testing_path)
    if( WIN32 )
        foreach( dir ${NDS_CLIENT_LIBRARY_DIRS} )
            get_filename_component( dir "${dir}/../bin" ABSOLUTE )
            file( TO_NATIVE_PATH ${dir} dir )
            list( APPEND TPATH ${dir} )
        endforeach( )
        list( APPEND TPATH  $ENV{PATH} )
        string( REPLACE ";" "\\;" TPATH "${TPATH}" )
        # message( FATAL_ERROR "DEBUG: TPATH: ${TPATH}" )
    else( WIN32 )
        set(TPATH "$ENV{PATH}")
    endif( WIN32 )
endmacro()

if ( ENABLE_SWIG_JAVA )
    include(CMakeParseArguments)
    include(UseCopyIfDifferent)

    file( TO_NATIVE_PATH ${Java_JAVA_EXECUTABLE} PROG_JAVA )
    if ( WIN32 )
        # string( REPLACE "\\" "\\\\" PROG_JAVA "${PROG_JAVA}" )
    endif( )

    get_filename_component( NDS_JAR "${CMAKE_CURRENT_BINARY_DIR}/../module/nds2.jar" ABSOLUTE )
    message( STATUS "NDS_JAR: ${NDS_JAR}" )

    set( MATLAB_TEST_FLAGS "")
    if ( MATLAB_NO_NODISPLAY )
        set ( MATLAB_TEST_FLAGS "--no-nodisplay" )
    endif ( MATLAB_NO_NODISPLAY )

    function(to_path_list var path1)
        if (WIN32)
            set(sep "\\;")
        else(WIN32)
            set(sep ":")
        endif(WIN32)
        set(result "${path1}") # First element doesn't require separator at all...
        foreach(path ${ARGN})
            set(result "${result}${sep}${path}") # ... but other elments do.
        endforeach(path)
        #list(APPEND result ${path1} ${ARGN})
        set(${var} "${result}" PARENT_SCOPE)
    endfunction(to_path_list)


    function(COMPILE_JAVA target)
        #--------------------------------------------------------------------
        # Parse the parameters
        #--------------------------------------------------------------------
        set(options)
        set(oneValueArgs)
        set(multiValueArgs SOURCES BINARY_SOURCES)
        cmake_parse_arguments( "" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
        message( STATUS "target: ${target} ARGN: ${ARGN}" )
        set(ALL_SOURCES "" )
        if( _SOURCES )
          set_source_files_properties( ${_SOURCES} PROPERTIES GENERATED TRUE )
          foreach( i ${_SOURCES} )
                list( APPEND ALL_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/${i}" )
                # list( APPEND ALL_SOURCES "${i}" )
            endforeach( i )
        endif( _SOURCES )
        message( STATUS "BINARY_SOURCES: ${_BINARY_SOURCES}" )
        if( _BINARY_SOURCES )
            foreach( i ${_BINARY_SOURCES} )
                list( APPEND ALL_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/${i}" )
                # list( APPEND ALL_SOURCES "${i}" )
            endforeach( i )
        endif( _BINARY_SOURCES )
        message( STATUS "ALL_SOURCES: ${ALL_SOURCES}" )
        #--------------------------------------------------------------------
        #
        #--------------------------------------------------------------------
        set(CMAKE_JAVA_COMPILE_FLAGS -source 1.6 -target 1.6 )
        #-------------------------------------------------------------------
        # Get source into local build directory
        #-------------------------------------------------------------------
        if ( _SOURCES )
            copy_if_different(
                ${CMAKE_CURRENT_SOURCE_DIR}
                ${CMAKE_CURRENT_BINARY_DIR}
                "${_SOURCES}"
                JavaStageTargets "JavaStage${target}" )
            add_custom_target( CopyJavaStage${target}
                ALL DEPENDS ${JavaStageTargets} )
        endif ( _SOURCES )
        #-------------------------------------------------------------------
        # Compile source
        #-------------------------------------------------------------------
        set( CMAKE_JAVA_INCLUDE_PATH ${NDS_JAR} )
        message( STATUS "DEBUG: NDS_JAR: ${NDS_JAR}" )
        add_jar( ${target}
            SOURCES ${ALL_SOURCES}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        add_dependencies( ${target} ndstesting nds2 nds2JNI )
        if( JavaStageTargets )
            add_dependencies( ${target} CopyJavaStage${target} )
        endif( JavaStageTargets )
    endfunction(COMPILE_JAVA)

    function(COMPILE_JAVA_TEST target)
        compile_java(${target} ${ARGN} )
    endfunction(COMPILE_JAVA_TEST)

    function(ADD_JAVA_TEST target)
        list(GET ARGN 0 cmd )
        set_testing_path( )
        to_path_list(java_test_jars ${CMAKE_CURRENT_BINARY_DIR}/${cmd}.jar ${NDS_JAR} )
        add_test( ${target}
            ${Java_JAVA_EXECUTABLE} -cp ${java_test_jars} -enableassertions ${CMAKE_JAVA_EXTRA_FLAGS} ${ARGN} )
        set( env 
              "PATH=${TPATH}"
              "JAVA=${PROG_JAVA}"
              ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
        set_test_properties( ${target}
            ENVIRONMENT "${env}"
            )
    endfunction(ADD_JAVA_TEST)

    #-----------------------------------------------------------------------
    # Need to build some scripts since they depend on dynamic data.
    #-----------------------------------------------------------------------

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version_java.java.in
                    ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version_java.java
                    @ONLY )

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version_matlab.m.in
                    ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version_matlab.m
                    @ONLY )

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/unittest.java
                    ${CMAKE_CURRENT_BINARY_DIR}/ndstesting/unittest.java
                    COPYONLY )
    #-----------------------------------------------------------------------
    #-----------------------------------------------------------------------
    compile_java(
        ndstesting
        BINARY_SOURCES
            "ndstesting/unittest.java" )
    #-----------------------------------------------------------------------
    # Run tests that depend on python
    #-----------------------------------------------------------------------
    if( PYTHON_DFLT_EXECUTABLE )
        #-------------------------------------------------------------------
        # All of these require python to run
        #-------------------------------------------------------------------
        function(null_server_test name command)
            set( _include_test TRUE )
            get_filename_component( COMMAND_EXT ${command} EXT )
            message( STATUS "Command extension: ${COMMAND_EXT}" )
            if( ${COMMAND_EXT} STREQUAL ".m" )
                if ( PROG_MATLAB )
                    list(APPEND COMMAND_OPTIONS --matlab=${PROG_MATLAB})
                    list(APPEND COMMAND_OPTIONS ${MATLAB_TEST_FLAGS})
                    list(APPEND COMMAND_OPTIONS --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar)
                else ( PROG_MATLAB )
                    set( _include_test FALSE )
                endif ( PROG_MATLAB )
            endif( ${COMMAND_EXT} STREQUAL ".m" )
            if ( _include_test )
                set_testing_path( )
                if (NOT IS_ABSOLUTE ${command})
                    if ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                        set( command "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                    elseif ( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                        set( command "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                    endif ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                endif (NOT IS_ABSOLUTE ${command})
                add_test(
                    NAME ${name}
                    COMMAND
                        ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                        ${COMMAND_OPTIONS}
                        --null-server
                        "${command}" )
                set( env
                    "PATH=${TPATH}"
                    "JAVA=${PROG_JAVA}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
                # message( FATAL_ERROR "DEBUG: env: ${env}" )
                set_tests_properties( ${name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        ENVIRONMENT "${env}"
                        )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                    CACHE INTERNAL "" )
            endif ( _include_test )
        endfunction(null_server_test)

        function(mock_server_test name command)
            set( _include_test TRUE )
            get_filename_component( COMMAND_EXT ${command} EXT )
            message( STATUS "Command extension: ${COMMAND_EXT}" )
            if( ${COMMAND_EXT} STREQUAL ".class" )
                set(COMMAND_DIR ${CMAKE_CURRENT_BINARY_DIR})
            else( ${COMMAND_EXT} STREQUAL ".class" )
                set(COMMAND_DIR ${CMAKE_CURRENT_SOURCE_DIR})
            endif( ${COMMAND_EXT} STREQUAL ".class" )
            if( ${COMMAND_EXT} STREQUAL ".m" )
                if ( PROG_MATLAB )
                    list(APPEND COMMAND_OPTIONS --matlab=${PROG_MATLAB})
                    list(APPEND COMMAND_OPTIONS ${MATLAB_TEST_FLAGS})
                    list(APPEND COMMAND_OPTIONS --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar)
                else ( PROG_MATLAB )
                    set( _include_test FALSE )
                endif ( PROG_MATLAB )
            endif( ${COMMAND_EXT} STREQUAL ".m" )
            if ( _include_test )
                set_testing_path( )
                add_test(
                    NAME ${name}
                    COMMAND
                        ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                        ${COMMAND_OPTIONS}
                        --nds1-mock-server
                        "${COMMAND_DIR}/${command}" )
                set( env
                    "PATH=${TPATH}"
                    "JAVA=${PROG_JAVA}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
                set_tests_properties( ${name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        ENVIRONMENT "${env}"
                          )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                    CACHE INTERNAL "" )
            endif ( _include_test )
        endfunction(mock_server_test)

        function(replay_server_test name command json)
            if ( REPLAY_BLOB_CACHE_DIR )
                set_nds_protocols(protocols ${name})
                foreach ( proto ${protocols} )
                    set(test_name "${name}${proto}_")
                    set( _include_test TRUE )
                    get_filename_component( COMMAND_EXT ${command} EXT )
                    if( ${COMMAND_EXT} STREQUAL ".m" )
                        if ( NOT PROG_MATLAB )
                            set( _include_test FALSE )
                        endif ( NOT PROG_MATLAB )
                    endif( ${COMMAND_EXT} STREQUAL ".m" )
                    if ( _include_test )
                        set_testing_path( )
                        add_test(
                            NAME ${test_name}
                            COMMAND
                                ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                                --matlab=${PROG_MATLAB}
                                ${MATLAB_TEST_FLAGS}
                                --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar
                                --replay-server
                                --replay-json-filename ${json}
                                --replay-protocol ${proto}
                                "${CMAKE_CURRENT_SOURCE_DIR}/${command}" ${ARGN} )
                        set( env
                            "PATH=${TPATH}"

=== matlab/module/CMakeLists.txt ===
# -*- mode: cmake; conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
if ( ENABLE_SWIG_JAVA AND ENABLE_SWIG_MATLAB )
  include(UseCopyIfDifferent)

  set(MATLAB_PACKAGE ndsm)

  set( MATLAB_SOURCES
      Depricated.m
      Availability.m
      Buffer.m
      Channel.m
      Connection.m
      ConnectionIterator.m
      Epoch.m
      Segment.m
      SimpleAvailabilityListType.m
      SimpleSegment.m
      version.m )
  copy_if_different(
      ${CMAKE_CURRENT_SOURCE_DIR}
      ${CMAKE_CURRENT_BINARY_DIR}/+${MATLAB_PACKAGE}
      "${MATLAB_SOURCES}"
      IncludeTargets "Includes" )
  add_custom_target(CopyIncludes ALL DEPENDS ${IncludeTargets})

  if( NOT WIN32 )
      configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/nds2-client-matlab.cfg.in
          ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-matlab.cfg
          @ONLY )
      install(
          FILES ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-matlab.cfg
          DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${PROJECT_BASENAME}
          COMPONENT MATLAB
          )
  endif( )
  install(
      FILES ${MATLAB_SOURCES}
      DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_BASENAME}/matlab/+${MATLAB_PACKAGE}"
      COMPONENT MATLAB
      )
endif ( )

=== matlab/test/CMakeLists.txt ===
# -*- conding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

macro(set_testing_path)
    if( WIN32 )
        foreach( dir ${NDS_CLIENT_LIBRARY_DIRS} )
            get_filename_component( dir "${dir}/../bin" ABSOLUTE )
            file( TO_NATIVE_PATH ${dir} dir )
            list( APPEND TPATH ${dir} )
        endforeach( )
        list( APPEND TPATH  $ENV{PATH} )
        string( REPLACE ";" "\\;" TPATH "${TPATH}" )
        # message( FATAL_ERROR "DEBUG: TPATH: ${TPATH}" )
    else( WIN32 )
        set(TPATH "$ENV{PATH}")
    endif( WIN32 )
endmacro()

if ( ENABLE_SWIG_JAVA AND ENABLE_SWIG_MATLAB )
    get_filename_component( NDS_JAR "${CMAKE_BINARY_DIR}/swig/java/module/nds2.jar" ABSOLUTE )

    set( MATLAB_TEST_FLAGS "" )
    set( MATLAB_TEST_DISPLAY_FLAGS "-nodisplay")
    if ( MATLAB_NO_NODISPLAY )
        set ( MATLAB_TEST_FLAGS "--no-nodisplay" )
        set ( MATLAB_TEST_DISPLAY_FLAGS "-nodesktop" "-nosplash" )
    endif ( MATLAB_NO_NODISPLAY )

    function(matlab_test name command)
        if ( ARGV2 )
            set( cmd_prefix ${ARGV2} )
        else ( ARGV2 )
            set( cmd_prefix ${CMAKE_CURRENT_SOURCE_DIR} )
        endif ( ARGV2 )
        if ( PROG_MATLAB )
            set_testing_path( )
            if (NOT IS_ABSOLUTE ${command})
                if ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                    set( command "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                elseif ( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                    set( command "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                endif ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
            endif (NOT IS_ABSOLUTE ${command})
            add_test(
                NAME ${name}
                COMMAND
                    "${PYTHON_DFLT_EXECUTABLE}" "${PROG_NDS_TESTER}" ${NDS_TESTER_FLAGS}
                    --matlab=${PROG_MATLAB} ${MATLAB_TEST_FLAGS}
                    --null-server
                    "${command}" )
            set( env 
                "PATH=${TPATH}"
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
            set_tests_properties( ${name}
                PROPERTIES
                    ENVIRONMENT "${env}"
                    SKIP_RETURN_CODE 77 )
            set( NDS_CUSTOM_MEMCHECK_IGNORE
                ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                CACHE INTERNAL "" )
        endif ( PROG_MATLAB )
    endfunction(matlab_test)

    function(mock_server_test name command)
        if ( PROG_MATLAB )
            set_testing_path( )
            add_test(
                NAME ${name}
                COMMAND
                    "${PYTHON_DFLT_EXECUTABLE}" "${PROG_NDS_TESTER}" ${NDS_TESTER_FLAGS}
                    --matlab=${PROG_MATLAB} ${MATLAB_TEST_FLAGS}
                    --nds1-mock-server
                    "${CMAKE_CURRENT_SOURCE_DIR}/${command}" )
            set( env 
                "PATH=${TPATH}"
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
            set_tests_properties( ${name}
                PROPERTIES
                    ENVIRONMENT "${env}"
                    SKIP_RETURN_CODE 77 )
            set( NDS_CUSTOM_MEMCHECK_IGNORE
                ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                CACHE INTERNAL "" )
        endif ( PROG_MATLAB )
    endfunction(mock_server_test)

    function(replay_server_test name command json)
        if ( PROG_MATLAB AND REPLAY_BLOB_CACHE_DIR )
            set_testing_path( )
            set_nds_protocols(protocols ${name})
            foreach ( proto ${protocols} )
                set(test_name "${name}${proto}_")
                add_test(
                    NAME ${test_name}
                    COMMAND
                        "${PYTHON_DFLT_EXECUTABLE}" "${PROG_NDS_TESTER}" ${NDS_TESTER_FLAGS}
                        --matlab=${PROG_MATLAB} ${MATLAB_TEST_FLAGS}
                        --replay-server
                        --replay-json-filename ${json}
                        --replay-protocol ${proto}
                        "${CMAKE_CURRENT_SOURCE_DIR}/${command}" ${ARGN} )
                set( env 
                    "PATH=${TPATH}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}
                    "REPLAY_BLOB_REMOTE_CACHE=${REPLAY_BLOB_CACHE_DIR}"
                    )
                set_tests_properties( ${test_name}
                    PROPERTIES
                        ENVIRONMENT "${env}"
                        SKIP_RETURN_CODE 77 )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${test_name}
                    CACHE INTERNAL "" )
            endforeach ( proto )
        endif ( PROG_MATLAB AND REPLAY_BLOB_CACHE_DIR )
    endfunction(replay_server_test)

    if( PYTHON_DFLT_EXECUTABLE )
        configure_file(
            ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version.m.in
            ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version.m
            @ONLY )

        #================================================================
        # These tests require a minimum of Python
        #================================================================
        # Final variable substitution before use
        #----------------------------------------------------------------
        string(CONFIGURE "${NDS_TESTER_FLAGS}" NDS_TESTER_FLAGS )
        #----------------------------------------------------------------
        matlab_test( _matlab_is-trend-type_
            test_is_trend_type.m )
        matlab_test( _matlab_version_
            test_nds2_version.m
            "${CMAKE_CURRENT_BINARY_DIR}" )
        #----------------------------------------------------------------
        mock_server_test( _matlab_mockup_ test_mockup.m )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_availability_
            test_nds2_availability.m
            nds2-availability.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds1_get-epochs_
            test_get_epochs.m
            nds1-get-epoch.json -proto-1 )
        replay_server_test(
            _matlab_nds2_get-epochs_
            test_get_epochs.m
            nds2-get-epoch.json -proto-2 )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_dissimilar-gaps_
            test_dissimilar_gaps.m
            nds2-dissimilar_gaps.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds1_iterate-with-gaps_
            test_iterate_with_gaps.m
            nds1-iterate_with_leading_gap.json
            -proto-1 )
        replay_server_test(
            _matlab_nds2_iterate-with-gaps_
            test_iterate_with_gaps.m
            nds2-iterate_with_leading_gap.json
            -proto-2 )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds1_iterate-with-synth-gaps_
            test_iterate_with_synth_gaps.m
            nds1-iterate-with-gaps-synthetic.json
            -proto-1
            )
        replay_server_test(
            _matlab_nds1_iterate-with-synth-gaps-nogaphandler_
            test_iterate_with_synth_gaps.m
            nds1-iterate-with-gaps-synthetic.json
            -proto-1 -no-gap
            )
        replay_server_test(
            _matlab_nds1_iterate-with-synth-gaps-defaultgaphandler_
            test_iterate_with_synth_gaps.m
            nds1-iterate-with-gaps-synthetic.json
            -proto-1 -default-gap-handling
            )
        #----------------------------------------------------------------
        replay_server_test(
                _matlab_nds1_restart_failure_
                test_nds1_restart_failure.m
                nds1-restart-failure.json
        )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_iterate-live-data-bounded_
            test_iterate_live_data_bounded.m
            nds2-iterate-live-data-bounded-synthetic.json
            -proto-2
            )
        replay_server_test(
            _matlab_nds1_iterate-live-data-bounded_
            test_iterate_live_data_bounded.m
            nds1-iterate-live-data-bounded-synthetic-multiconn.json
            -proto-1
            )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_iterate-live-data_
            test_iterate_live_data.m
            nds2-iterate-live-data-synthetic.json
            -proto-2
            )
        replay_server_test(
            _matlab_nds1_iterate-live-data_
            test_iterate_live_data.m
            nds1-iterate-live-data-synthetic.json
            -proto-1
            )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_iterate-all-data_
            test_iterate_all_data.m
            nds2-iterate-all-data-synthetic.json
            -proto-2
            )
        replay_server_test(
            _matlab_nds1_iterate-all-data_
            test_iterate_all_data.m
            nds1-iterate-all-data-synthetic.json
            -proto-1
            )
        replay_server_test(
            _matlab_nds2_iterate-all-data-nogaphandler_
            test_iterate_all_data.m
            nds2-iterate-all-data-synthetic.json
            -proto-2 -no-gap
            )
        replay_server_test(
            _matlab_nds1_iterate-all-data-nogaphandler_
            test_iterate_all_data.m
            nds1-iterate-all-data-synthetic.json
            -proto-1 -no-gap
            )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds1_count-channels_
            test_count_channels.m
            nds1-count-channels-synthetic.json
            -proto-1 )
        replay_server_test(
            _matlab_nds2_count-channels_
            test_count_channels.m
            nds2-count-channels-synthetic.json
            -proto-2 )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds1_timeout_
            test_nds1_timeout.m
            nds1-timeout.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_ticket-169_
            test_ticket_169.m
            nds2-ticket-169.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_ticket-246_
            test_ticket_246.m
            nds2-ticket-246.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds1_ticket-260_
            test_nds1_ticket_260.m
            nds1-ticket-260.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_ticket-288_
            test_ticket_288.m
            nds2-ticket-288.json )
        #----------------------------------------------------------------
        replay_server_test(
            _matlab_nds2_ticket-289_
            test_ticket_289.m
            nds2-ticket-289.json )
    endif( PYTHON_DFLT_EXECUTABLE )
endif ( ENABLE_SWIG_JAVA AND ENABLE_SWIG_MATLAB )

=== octave/module/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

if (ENABLE_SWIG_OCTAVE)
    include_directories(
        BEFORE
        ${PROJECT_SOURCE_DIR}/common/module
        ${PROJECT_BINARY_DIR}/common/module
        ${PROJECT_BINARY_DIR}/src/client
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${nds2-client_INCLUDE_DIRS}
        ${HDF5_INCLUDE_DIRS}
        ${OCTAVE_INCLUDE_DIRS}
        )

    if( NOT OCTAVE_INSTALL_DIR )
        set( OCTAVE_INSTALL_DIR ${CMAKE_INSTALL_LIBEXECDIR}/${PROJECT_BASENAME}/octave CACHE PATH "Installation directory for Octave modules" )
    endif( NOT OCTAVE_INSTALL_DIR )

    set(INTERFACE_FILE "nds_octave.i")

    set(CMAKE_SWIG_FLAGS "-O")
    set_source_files_properties(${INTERFACE_FILE} PROPERTIES
        CPLUSPLUS ON
        SWIG_FLAGS "-includeall"
    )
    set_source_files_properties(nds2OCTAVE_wrap.cxx PROPERTIES
        GENERATED true
    )
    if ( COMMAND SWIG_ADD_LIBRARY )
        swig_add_library(
            nds2_octave 
            LANGUAGE octave
            SOURCES ${INTERFACE_FILE}
            )
    else( )
        swig_add_module(nds2_octave octave ${INTERFACE_FILE})
    endif( )
    swig_link_libraries(nds2_octave ${OCTAVE_LIBRARIES} nds::cxx)
    set_target_properties(nds2_octave PROPERTIES
        OUTPUT_NAME nds2
        LINKER_LANGUAGE CXX
    )
    if ( ${OCTAVE_VERSION_STRING} VERSION_GREATER "4.0" )
        target_compile_features(nds2_octave PRIVATE
            cxx_variadic_macros
            )
    elseif ( ${OCTAVE_VERSION_STRING} VERSION_EQUAL "4.0" )
        target_compile_features(nds2_octave PRIVATE
            cxx_variadic_macros
            )
    endif ( ${OCTAVE_VERSION_STRING} VERSION_GREATER "4.0" )

  #======================================================================
  # Configuration information
  #======================================================================
  configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/nds2-client-octave.cfg.in
      ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-octave.cfg
      @ONLY )
  #======================================================================
  # Installation Rules
  #======================================================================
  get_swig_property( nds2_module_filename MODULE_OUTPUT_NAME nds2_octave )

  if( NOT WIN32)
      install(
          FILES ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-octave.cfg
          DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${PROJECT_BASENAME}
          COMPONENT Octave
          )
  endif( NOT WIN32)

  install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/${nds2_module_filename}
    DESTINATION ${OCTAVE_INSTALL_DIR}
    COMPONENT Octave
  )


endif(ENABLE_SWIG_OCTAVE)

=== debian/changelog ===
nds2-client-swig (0.16.3-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 02 Nov 2018 11:16:25 -0700

nds2-client-swig (0.16.2-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Mon, 22 Oct 2018 09:25:14 -0700

nds2-client-swig (0.16.1-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 03 Aug 2018 09:38:11 -0700

nds2-client-swig (0.16.0-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 02 Aug 2018 13:32:57 -0700

nds2-client-swig (0.15.3-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 14 Mar 2018 13:39:41 -0700

=== debian/control ===
Source: nds2-client-swig
Section: net
Priority: optional
Maintainer: Edward Maros <ed.maros@ligo.org>
Build-Depends:
 debhelper (>= 9),
 dh-python,
 cmake,
 gawk,
 pkg-config,
 swig (>= 3.0.7),
 python,
 python-all-dev,
 python-numpy,
 python3-all-dev,
 python3-numpy,
 default-jdk,
 octave | octave3.2 | octave3.0,
 liboctave-dev | octave3.2-headers | octave3.0-headers,
 libnds2-client-dev (>= 0.16.0)
Standards-Version: 3.9.8
Homepage: https://wiki.ligo.org/DASWG/NDSClient

Package: nds2-client-swig
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 krb5-user
Suggests:
 libnds2-client-java,
 libnds2-client-matlab,
 octave-nds2-client,
 python-nds2-client,
 python3-nds2-client
Description: NDS2 client binaries
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes some client binary examples.

Package: libnds2-client-java
Section: java
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client java interface
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated java bindings, which are
 also usable from Matlab.

Package: octave-nds2-client
Architecture: any
Depends:
 libnds2-client (>= 0.16.0),
 octave,
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client octave bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated octave bindings.

Package: python-nds2-client
Section: python
Architecture: any
Depends: ${python:Depends},
 libnds2-client (>= 0.16.0),
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client python bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated python bindings.

Package: python3-nds2-client
Section: python
Architecture: any
Depends: ${python34:Depends},
 libnds2-client (>= 0.16.0),
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client python 3.4 bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated python bindings.

Package: libnds2-client-matlab
Architecture: any
Depends:
 libnds2-client-java (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client MATLAB interface
 This provides MATLAB wrappers for the nds2 client

Package: nds2-client-swig-all
Architecture: any
Depends:
 ${misc:Depends},
 libnds2-client-java (= ${binary:Version}),
 libnds2-client-matlab (= ${binary:Version}),
 octave-nds2-client (= ${binary:Version}),
 python-nds2-client (= ${binary:Version}),
 python3-nds2-client (= ${binary:Version})
Description: NDS2 meta package
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package installs all NDS2 client packages, including libraries,
 language bindings, binary interface, and documentation.
